Pro baraffe_interpol, age_vec, mass_vec, MJ_tab, MH_tab, MK_tab, W1_tab, W2_tab, Li_tab, MAX_MASS=max_mass
  ;This routine requires the "barrafe_interpol_input.sav" IDL data save file. Please obtain this file at 
  ;http://sites.google.com/site/mbderg/banyanii_additional_material under section 5.6 and update the
  ;"idl_datasave_path" variable to a valid path on your computer leading to the file. 
  
  idl_datasave_path = 'baraffe_interpol_input.sav'
  
  forward_function array_indices
  
  restore, idl_datasave_path
  
  nvec = 1500
  if ~ keyword_set(max_mass) then $
    max_mass = 0.2
  if ~keyword_set(mass_vec) then $
    mass_vec = dindgen(nvec)/(nvec-1.)*(max_mass-min(struc.m))+min(struc.m)
  nage = n_elements(age_vec)
  
  ;Si l'age ou la masse depasse de la grille on retourne des NaN
  ;Pour chaque point dans mass_vec, on regarde le point de masse le plus pres dans la grille et on se demande si age_vec depasse.
  av2d = age_vec#make_array(n_elements(struc),value=1d0,/double)
  void = min(abs(av2d-make_array(nage,value=1d0,/double)#struc.AGE),dim=2,ind1d)
  ind = array_indices(av2d,ind1d)
  gg = where(struc.AGE eq struc[ind[1]].AGE, ngg)
  badmass = where(mass_vec gt max(struc[gg].m,/nan) or mass_vec lt min(struc[gg].m,/nan), nbadmass)
  
  gd = where(finite(struc.MJ))
  triangulate, alog10(struc[gd].AGE), alog10(struc[gd].M), triangles
  MJ_tab = reform(griddata(alog10(struc[gd].AGE), alog10(struc[gd].M), struc[gd].MJ, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  gd = where(finite(struc.MH))
  triangulate, alog10(struc[gd].AGE), alog10(struc[gd].M), triangles
  MH_tab = reform(griddata(alog10(struc[gd].AGE), alog10(struc[gd].M), struc[gd].MH, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  gd = where(finite(struc.MK))
  triangulate, alog10(struc[gd].AGE), alog10(struc[gd].M), triangles
  MK_tab = reform(griddata(alog10(struc[gd].AGE), alog10(struc[gd].M), struc[gd].MK, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  
  gd = where(finite(strucw.w1_w10))
  triangulate, alog10(strucw[gd].AGE), alog10(strucw[gd].M), triangles
  W1_tab = reform(griddata(alog10(strucw[gd].AGE), alog10(strucw[gd].M), strucw[gd].W1_W10, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  gd = where(finite(strucw.w2_w10))
  triangulate, alog10(strucw[gd].AGE), alog10(strucw[gd].M), triangles
  W2_tab = reform(griddata(alog10(strucw[gd].AGE), alog10(strucw[gd].M), strucw[gd].W2_W10, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  
  gd = where(finite(struc.Li))
  triangulate, alog10(strucw[gd].AGE), alog10(strucw[gd].M), triangles
  Li_tab = reform(griddata(alog10(struc[gd].AGE), alog10(struc[gd].M), struc[gd].Li, MISSING=!values.f_nan, xout=[alog10(age_vec)], yout=alog10(mass_vec), $
    TRIANGLES=triangles,DIMENSION=[nage,nvec], /grid, /Linear))
  
  if nbadmass ne 0 then begin
    MJ_tab[badmass] = !values.f_nan
    MH_tab[badmass] = !values.f_nan
    MK_tab[badmass] = !values.f_nan
    W1_tab[badmass] = !values.f_nan
    W2_tab[badmass] = !values.f_nan
    Li_tab[badmass] = !values.f_nan
  endif
  
End